package meerkat.bulletinboard.callbacks;

import com.google.common.util.concurrent.FutureCallback;
import com.google.common.util.concurrent.Futures;
import com.google.common.util.concurrent.ListeningExecutorService;
import meerkat.bulletinboard.BulletinClientJob;
import meerkat.bulletinboard.BulletinClientJobResult;
import meerkat.bulletinboard.BulletinClientWorker;
import meerkat.protobuf.BulletinBoardAPI;

import java.util.List;

/**
 * This is a future callback used to listen to workers and run on job finish
 * Depending on the type of job and the finishing status of the worker: a decision is made whether to retry or return an error
 */
public abstract class ClientFutureCallback implements FutureCallback<BulletinClientJobResult> {

    protected ListeningExecutorService listeningExecutor;

    ClientFutureCallback(ListeningExecutorService listeningExecutor) {
        this.listeningExecutor = listeningExecutor;
    }

}
