package SecureDistributedKeyGenerationForDiscreteLogBasedCryptosystem;

import JointFeldmanProtocol.DistributedKeyGenerationParty;
import ShamirSecretSharing.Polynomial;

import java.math.BigInteger;
import java.util.HashSet;
import java.util.Set;

/**
 * Created by Tzlil on 3/16/2016.
 *
 * an extension of DistributedKeyGenerationParty
 * contains all relevant information on specific party during
 * the run of the safe protocol
 */
public class SecureDistributedKeyGenerationParty extends DistributedKeyGenerationParty {
    public Polynomial.Point shareT;
    public boolean ysDoneFlag;
    public BigInteger[] verifiableValues;
    public Set<Polynomial.Point> restoreSharesSet;
    public SecureDistributedKeyGenerationParty(int id, int n, int t) {
        super(id, n, t);
        this.shareT = null;
        this.ysDoneFlag = false;
        this.verifiableValues = new BigInteger[t + 1];
        this.restoreSharesSet = new HashSet<Polynomial.Point>();
    }
}
