package SecureDistributedKeyGenerationForDiscreteLogBasedCryptosystem;

import Communication.Network;
import JointFeldmanProtocol.DistributedKeyGeneration;

import java.math.BigInteger;
import java.util.Random;
import java.util.Set;

/**
 * Created by Tzlil on 3/29/2016.
 */
public class SDKGMaliciousUserImpl extends SecureDistributedKeyGenerationUserImpl {

    private final DistributedKeyGeneration maliciousSDKG;
    private final Set<Integer> falls;
    public SDKGMaliciousUserImpl(SecureDistributedKeyGeneration sdkg,SecureDistributedKeyGeneration maliciousSDKG
            , Network network,Set<Integer> falls) {
        super(sdkg, network);
        this.falls = falls;
        this.maliciousSDKG = maliciousSDKG;
        maliciousSDKG.setParties(parties);
    }

    public static SecureDistributedKeyGeneration generateMaliciousSDKG(SecureDistributedKeyGeneration sdkg,Random random){
        BigInteger q = sdkg.getQ();
        BigInteger zi = new BigInteger(q.bitLength(), random).mod(q);
        return new SecureDistributedKeyGeneration(sdkg.getT(),sdkg.getN(),zi,random,sdkg.getQ()
                ,sdkg.getGenerator(),sdkg.getH(),sdkg.getGroup(),sdkg.getId());
    }

    @Override
    public void stage1() {
        sdkg.broadcastVerificationValues(user);
        sendSecrets(); //insteadof dkg.sendSecrets(user);
    }

    @Override
    public void stage3() {
        stopReceiver();
        maliciousSDKG.answerAllComplainingPlayers(user);
    }

    @Override
    public void stage4(){
        //do nothing
    }

    private void sendSecrets(){
        for (int j = 1; j <= n ; j++){
            if(j != id){
                if(falls.contains(j)){
                    maliciousSDKG.sendSecret(user,j);
                }else {
                    sdkg.sendSecret(user, j);
                }
            }
        }
    }

}
