package SecureDistributedKeyGenerationForDiscreteLogBasedCryptosystem;

import Communication.Network;
import SecureDistributedKeyGenerationForDiscreteLogBasedCryptosystem.SecureDistributedKeyGeneration;
import SecureDistributedKeyGenerationForDiscreteLogBasedCryptosystem.SecureDistributedKeyGenerationUserImpl;
import meerkat.protobuf.DKGMessages;

/**
 * Created by Tzlil on 3/14/2016.
 */
public class SDKGUserImplAbort extends SecureDistributedKeyGenerationUserImpl {

    final int abortStage;
    int stage;
    public SDKGUserImplAbort(SecureDistributedKeyGeneration sdkg, Network network, int abortStage) {
        super(sdkg, network);
        this.abortStage = abortStage;// 1 - 4
        this.stage = 1;
    }

    private void abort(){
        stopReceiver();
        user.broadcast(DKGMessages.Mail.Type.ABORT,DKGMessages.EmptyMessage.getDefaultInstance());
    }

    @Override
    protected void stage1() {
        if(stage < abortStage)
            super.stage1();
        else if(stage == abortStage){
            abort();
        }
        stage++;
    }

    @Override
    protected void stage2() {
        if(stage < abortStage)
            super.stage2();
        else if(stage == abortStage){
            abort();
        }
        stage++;
    }

    @Override
    protected void stage3() {
        if(stage < abortStage)
            super.stage3();
        else if(stage == abortStage){
            abort();
        }
        stage++;
    }

    @Override
    protected void stage4() {
        if(stage < abortStage)
            super.stage4();
        else if(stage == abortStage){
            abort();
        }
        stage++;
    }
}
